var mozless_focusMode;
var mozless_prefEmacsKeys;

function mozless_init(e) {
  mozless_focusMode = mozlessReadPref('focusmode');
  mozless_prefEmacsKeys = mozlessReadPref('emacskeys');
}

window.addEventListener("load", mozless_init, true);

function mozless_focusTop() {
  if (!document.getElementById("FindToolbar").hidden) return;

  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i].offsetTop >= w.pageYOffset
	&& links[i].offsetTop < w.pageYOffset + w.innerHeight) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusBottom()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i].offsetTop < w.pageYOffset + w.innerHeight
	&& links[i].offsetTop >= w.pageYOffset) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusPrev() {
  if (!document.getElementById("FindToolbar").hidden) return;

  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusBottom();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusBottom();
  }
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i] == focus) {
      if (i-1 >= 0) {
	links[i-1].focus();
	links[i-1].select();
      }
      return;
    }
  }
}

function mozless_focusNext() {
  if (!document.getElementById("FindToolbar").hidden) return;

  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusTop();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusTop();
  }
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i] == focus) {
      if (i+1 < links.length) {
	links[i+1].focus();
	links[i+1].select();
      }
      return;
    }
  }
}

//--------------------------------------------------------------------

function mozless_keyFocusMode()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  mozless_focusMode = !mozless_focusMode;
}

function mozless_keyPrev()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  if (mozless_focusMode) {
    mozless_focusPrev();
  } else {
    goDoCommand('cmd_scrollLineUp');
  }
}

function mozless_keyNext()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  if (mozless_focusMode) {
    mozless_focusNext();
  } else {
    goDoCommand('cmd_scrollLineDown');
  }
}

function mozless_keyBack()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  if (mozless_focusMode) {
    BrowserBack();
  } else {
    goDoCommand('cmd_scrollLeft');
  }
}

function mozless_followLink()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  var focus = document.commandDispatcher.focusedElement;
  if (!focus) return;
  window._content.open(focus.href, "_self");
}

function mozless_keyForward()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  if (mozless_focusMode) {
    mozless_followLink();
  } else {
    goDoCommand('cmd_scrollRight');
  }
}

function mozless_keyPageUp()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  goDoCommand('cmd_scrollPageUp');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_keyPageDown()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  goDoCommand('cmd_scrollPageDown');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_keyHalfPageUp()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  window._content.scrollBy(0, -window._content.innerHeight/2);
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_keyHalfPageDown()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  window._content.scrollBy(0, window._content.innerHeight/2);
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_keyTop()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  goDoCommand('cmd_scrollTop');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_keyBottom()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  goDoCommand('cmd_scrollBottom');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_movePageUp()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  mozless_keyPageUp(); // XXX - Not a scrolling?
}

function mozless_movePageDown()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  mozless_keyPageDown(); // XXX - Not a scrolling?
}

function mozless_openBookmarks()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  var dirService = Components
    .classes['@mozilla.org/file/directory_service;1']
    .getService(Components.interfaces.nsIProperties);

  const NS_APP_USER_PROFILE_50_DIR = "ProfD";
  profileDir = dirService.get(NS_APP_USER_PROFILE_50_DIR, Components.interfaces.nsIFile);

  var bookmarksURL = "file://" + profileDir.path + "/bookmarks.html";
  window._content.open(bookmarksURL, "_self");
}

//
// emacs keys
//

// NOTE: most *Browser*() functions are in the Firefox Source:
// mozilla/browser/base/content/browser.js

function mozless_emacsKeyPrev()
{
  if (mozless_prefEmacsKeys) mozless_keyPrev();
  //else BrowserPrint(); //XXX ??
  else PrintUtils.print(); //XXX ??
}

function mozless_emacsKeyNext()
{
  if (mozless_prefEmacsKeys) mozless_keyNext();
  else OpenBrowserWindow();
}

function mozless_emacsKeyBack()
{
  if (mozless_prefEmacsKeys) mozless_keyBack();
  else toggleSidebar('viewBookmarksSidebar');
}

function mozless_emacsKeyForward()
{
  if (mozless_prefEmacsKeys) mozless_keyForward();
  else {
    openFindBar(); // not focused nor selected!!
    selectFindBar();
    // NOTE: *FindBar() functions are in the Firebird source:
    // mozilla/toolkit/components/typeaheadfind/content/findBar.js
  }
}

function mozless_emacsKeyJ()
{
  if (mozless_prefEmacsKeys) mozless_keyNext();
  //else BrowserPageInfo(); //XXX ??
}

function mozless_emacsKeyV()
{
  if (mozless_prefEmacsKeys) mozless_keyPageDown();
}

//
// w3m keys
//

function mozless_w3mKeyGoBack()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserBack();
}

function mozless_w3mKeyGoForward()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserForward();
}

function mozless_w3mKeyReload()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserReload();
}

function mozless_w3mKeyStop()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserStop();
}

function mozless_w3mKeyGoHome()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserHome();
}

function mozless_w3mKeyFocusURLBar()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  openLocation();
}

//
// common keys, again
//

function mozless_findNext()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  findNext();
}

function mozless_findPrevious()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  findPrevious();
}

function mozless_close()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserCloseTabOrWindow();
}

function mozless_closeWindow()
{
  if (!document.getElementById("FindToolbar").hidden) return;

  BrowserCloseWindow();
}
